package hsql_bsp3;

import java.awt.event.MouseEvent;
import java.text.DecimalFormat;

import java.util.*;
import javax.swing.JOptionPane;
import java.io.*;

public class Basis {

    // Konstanten
    public static final int C_LEER = 1;
    public static final int C_KEINEZAHL = 2;
    public static final int C_ZUKLEIN = 3;
    public static final int C_ZUGROSS = 4;
    
    public static final int YES = 1;
    public static final int NO = 2;
    public static final int ESC = 3;
    
    
      // Konstanten für den Error Code als String
    public static final String SZ_LEER = "Leerer Text";
    public static final String SZ_KEINEZAHL = "Konvertierung schlug fehl";
    public static final String SZ_ZUKLEIN = "Für den Bereich zu klein";
    public static final String SZ_ZUGROSS = "Für den Bereich zu groß";

    public static int intVal;          // speichert das Ergebnis
    public static long longVal;        // speichert das Ergebnis
    public static double dblVal;       // speichert das Ergebnis

    private static int ValError = 0;   // speichert den Konvertierungfehler
    
    
    public static String getDatum() {
        Calendar cl = Calendar.getInstance();               
        int year = cl.get(Calendar.YEAR);
        int month = cl.get(Calendar.MONTH);
        int day = cl.get(Calendar.DATE);
        return Int2Str(day)+"."+Int2Str(month)+"."+year;
    }
    
  private static String Int2Str(int value) {
    String erg = Integer.toString(value);
    if (erg.length()<2) erg="0"+erg;
    return erg;
  }
    
    public static String getHsqlDatum() {
        Calendar cl = Calendar.getInstance();               
        int year = cl.get(Calendar.YEAR);
        int month = cl.get(Calendar.MONTH);
        int day = cl.get(Calendar.DATE);
        return year+"-"+ Int2Str(month)+"-"+ Int2Str(day);
    }
    
    public static String readLines(String filename){    
        FileInputStream fin;
        InputStreamReader iin;
        LineNumberReader din;
        StringBuilder sb = new StringBuilder();
        try {
          String lines="";
          fin = new FileInputStream(filename);
          iin = new InputStreamReader(fin);
          din = new LineNumberReader(iin);  // oder BufferedReader br = new BufferedReader(ir);
          while  ( din.ready() ) {          
            sb.append(din.readLine());
            sb.append("\n");
          }
        }
         catch (FileNotFoundException e1) {
             System.err.println("Die Datei war nicht vorhanden!");
        }
        catch (IOException ee) {
               System.err.println("IOException: " + ee);
        }
        return sb.toString();
    }
    
        public static String DeleteBadDBChars(String input) {
            String output;            
            output = input.replace("*", "");
            output = output.replace("?", "");
            output = output.replace("\"", "");
            return output;
        }


        public static String DeleteBadFilenameChars(String input) {
            String output;
            output = input.replace(";", "");
            output = output.replace(":", "");
            output = output.replace(",", "");
            output = output.replace("=", "");
            output = output.replace("+", "");
            output = output.replace("<", "");
            output = output.replace(">", "");
            output = output.replace("|", "");
            output = output.replace("\"", "");
            output = output.replace("/", "");
            output = output.replace("\\", "");
            output = output.replace("[", "");
            output = output.replace("]", "");
            output = output.replace("{", "");
            output = output.replace("}", "");
            output = output.replace("*", "");
            output = output.replace("?", "");
            return output;
        }


        public static String UML(String input) {
            String output;
            if (input == null) return "";
            output = input.replace("ä", "&#228;");
            output = output.replace("ä", "&#228;");
            output = output.replace("Ä", "&#196;");
            output = output.replace("ö", "&#246;");
            output = output.replace("Ö", "&#214;");
            output = output.replace("ü", "&#252;");
            output = output.replace("Ü", "&#220;");
            output = output.replace("0", "&#223;");
            output = output.replace(">", "&#62;");
            output = output.replace("<", "&#60;");
            return output;
        }
        
        public static void ErrorMsg(String message, String title) {
            JOptionPane.showConfirmDialog(null,message,title,
              JOptionPane.DEFAULT_OPTION,
              JOptionPane.ERROR_MESSAGE);  // Symbol
            
        }
        
        
  /**
    * description: Zeigt eine Nachricht an   
    * @see Message, Yes-No, Yes-No-Esc, Ok-Esc
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sTitle, String sMessage
    * @return keinen
    * @exception keine
    */
  public static void Message( String sTitle, String sMessage) {
    JOptionPane.showConfirmDialog(null,sMessage,sTitle,
      JOptionPane.DEFAULT_OPTION,
      JOptionPane.INFORMATION_MESSAGE);  // Symbol
    /*  Optionen der Schalter:
         DEFAULT_OPTION    Ok
         YES_NO_OPTION
         YES_NO_CANCEL_OPTION
         OK_CANCEL_OPTION
     */
     /*  Symbole:
      ERROR_MESSAGE
      INFORMATION_MESSAGE
      WARNING_MESSAGE
      QUESTION_MESSAGE
      PLAIN_MESSAGE
     */

  } // Message
        
        
        
        
    /**
    * description: Zeigt einen Ja-Nein-Dialog   
    * @see Message, Error, Yes-No-Esc, Ok-Esc
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sTitle, String sMessage
    * @return boolean
    * @exception keine
    */
  public static boolean YesNo( String sTitle, String sMessage) {
    int retcode;
    retcode = JOptionPane.showConfirmDialog(null,sMessage,sTitle,
      JOptionPane.YES_NO_OPTION,
      JOptionPane.QUESTION_MESSAGE);  // Symbol

    switch (retcode) {
       case JOptionPane.YES_OPTION:
         // ja, Änderungen speichern
         return true;
       case JOptionPane.NO_OPTION:
         return false;
       case JOptionPane.CANCEL_OPTION:
       default:
         // abbrechen
         return false;
    }
  } // YesNo


    /**
    * description: Zeigt einen Ja-Nein-Abbruch-Dialog   
    * @see Message, Error, Yes-No, Ok-Esc
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sTitle, String sMessage
    * @return int YES_OPTION, NO_OPTION, CANCEL_OPTION
    * @exception keine
    */
  public static int YesNoEsc( String sTitle, String sMessage) {
    int retcode;
    retcode = JOptionPane.showConfirmDialog(null,sMessage,sTitle,
      JOptionPane.YES_NO_CANCEL_OPTION,
      JOptionPane.QUESTION_MESSAGE);  // Symbol

    switch (retcode) {
       case JOptionPane.YES_OPTION:
         // ja, Änderungen speichern
         return YES;
       case JOptionPane.NO_OPTION:
         return NO;
       case JOptionPane.CANCEL_OPTION:
       default:
         return ESC;
    }
  } // YES NO ESC
        
        
    public static String getFileName(String sFileName) {
        int k, i, n;
        n = sFileName.length();
        k = sFileName.lastIndexOf(".");
        if (k == -1)
            return sFileName;
        else
            return sFileName.substring(0, k);  // ohne Punkt
    }  // getFileName

        
    
    public static String getFilenameExt(String sFileName) {
        int k, n;
        n = sFileName.length();
        k = sFileName.lastIndexOf("\\");
        if (k == -1) {
            // test mit /
            k = sFileName.lastIndexOf("/");
            if (k == -1)
                return sFileName;
            else {
                  // beginIndex   endIndex
                return sFileName.substring(k+1, n); // ??????  n-1 ist zu klein            
            }
        }
        else {
              // beginIndex   endIndex
            return sFileName.substring(k+1, n); // ??????  n-1 ist zu klein                        
        }
    }  // getFileNameExt

    /**
    * description: Konvertiert einen String in eine int-Variable   
    * Verwendet eine interne Variable zum Speichern des Wertes
    * @see IVal, getValResult
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sText
    * @return int
    * @exception keine
    */
    public static int IntVal(String sText) {
        // erläuterung von iIVal = Integer.valueOf(szText).intValue();
        String s;
        int intVal;
        s = new String(sText); // neues Objekt
        s = s.trim();  // Leerstellen löschen
        if (s.length() == 0 ) {
            return 0;
        }
        else {
            try {
                intVal = Integer.valueOf(sText).intValue();
                return intVal;
            }
            catch (NumberFormatException e) {
                return 0;
            }
        }
    } // IntVal

    
    /**
    * description: überprüft, ob der String eine Integerzahl ist
    * Verwendet eine interne Variable zum Speichern des Wertes
    * @see DVal, LVal, getErrorCode
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sText
    * @return boolean
    * @exception keine
    */
    public static boolean IVal(String sText) {
        // erläuterung von iIVal = Integer.valueOf(szText).intValue();
        boolean result = true;
        String s;
        s = new String(sText); // neues Objekt
        s.trim();
        if (s.length() == 0) {
            ValError = C_LEER;
            intVal = 0;
            result = false;
        }
        else {
            try {
                intVal = Integer.valueOf(sText).intValue();
                ValError = 0;
            }
            catch (NumberFormatException e) {
                // Check ob die "Zahl" für den Integerbereich zu klein oder zu groß
                // System.err.println(e);
                try {
                    dblVal = Double.valueOf(sText).doubleValue();
                    if ( dblVal<Integer.MIN_VALUE) {
                      ValError = C_ZUKLEIN;
                    }
                    if ( dblVal>Integer.MAX_VALUE) {
                      ValError = C_ZUGROSS;
                    }
                }
                catch (NumberFormatException e2) {
                    ValError = C_KEINEZAHL;
                    intVal = 0;
                    result = false;
                }
                intVal = 0;
                result = false;
            }
        }
        return result;
    } // IVal

    
    /**
    * DVal
    * description: überprüft, ob der String eine Double-Zahl ist
    * Verwendet eine interne Variable zum Speichern des Wertes
    * @see IVal, LVal, getErrorCode
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sText
    * @return boolean
    * @exception keine
    */
    public static boolean DVal(String sText) {
        // erläuterung von iIVal = Integer.valueOf(szText).intValue();
        boolean result = true;
        String s;
        s = new String(sText); // neues Objekt
        s.trim();
        if (s.length() == 0) {
            ValError = C_LEER;
            dblVal = 0;
            result = false;
        }
        else {
            try {
                dblVal = Double.valueOf(sText).doubleValue();
                ValError = 0;
            }
            catch (NumberFormatException e) {
                ValError = C_KEINEZAHL;
                dblVal = 0;
                result = false;
            }
        }
        return result;
    } // DVal

    
    /**
    * description: überprüft, ob der String eine Integerzahl ist
    * Verwendet eine interne Variable zum Speichern des Wertes
    * @see DVal, LVal, getErrorCode
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sText
    * @return boolean
    * @exception keine
    */
    public static boolean LVal(String sText) {
        // erläuterung von iIVal = Integer.valueOf(szText).intValue();
        boolean result = true;
        String s;
        s = new String(sText); // neues Objekt
        s.trim();
        if (s.length() == 0) {
            ValError = C_LEER;
            longVal = 0;
            result = false;
        }
        else {
            try {
                longVal = Long.valueOf(sText).longValue();
                ValError = 0;
            }
            catch (NumberFormatException e) {
                // Check ob die "Zahl" für den Longbereich zu klein oder zu groß                
                try {
                    dblVal = Double.valueOf(sText).doubleValue();
                    if ( dblVal<Long.MIN_VALUE) {
                      ValError = C_ZUKLEIN;
                    }
                    if ( dblVal>Long.MAX_VALUE) {
                      ValError = C_ZUGROSS;
                    }
                }
                catch (NumberFormatException e2) {
                    ValError = C_KEINEZAHL;
                    longVal = 0;
                    result = false;
                }
                longVal = 0;
                result = false;
            }
        }
        return result;
    } // IVal
    

  // welche Maustaste wurde gedrückt
    public static int getButton(MouseEvent e) {
        int mode = e.getModifiers();
        if ((mode & e.BUTTON2_MASK) > 0) {
            return 2;
        }
        if ((mode & e.BUTTON3_MASK) > 0) {
            return 3;
        }
        return 1;
    } // getButton
    

    
}
