package hsql_bsp3;

import java.sql.*;
import java.util.ArrayList;
import java.util.Vector;



public class Dbs {
    
    String databaseFile="";
    String filename="";
    
    Connection conn = null;
    
    
    private static Dbs dbs = new Dbs();

    public static Dbs getDbsInstance() {
        return dbs;
    }
    
    
    public long getSequenz(String seqname) {
        String sql = "SELECT NEXT VALUE FOR "+seqname+" FROM Sequenz;";
        DataTable dt = selectDBS(sql);
        ArrayList<String> tupel = dt.tableRows.get(0);
        long pindex = Long.valueOf(tupel.get(0));
        return pindex;            
    }

    
    public void openDbs() {
        if (!databaseFile.equals("")) {
            try {
                String sUsr="sa";
                String sPwd="";
                String sDbDrv="org.hsqldb.jdbcDriver";
                String sDbUrl="jdbc:hsqldb:"+ databaseFile;            
                Class.forName( sDbDrv );  // erzeugen und 
                conn = DriverManager.getConnection( sDbUrl, sUsr, sPwd );
            } catch( SQLException e1 ) {
              System.out.println( e1 );
            }
            catch( ClassNotFoundException e2 ) {
              System.out.println( e2 );
            }            
        }        
    }
    
    public void setDbs(String databaseFile) {
        try {
            this.databaseFile = databaseFile;

            String sUsr="sa";
            String sPwd="";
            String sDbDrv="org.hsqldb.jdbcDriver";
            String sDbUrl="jdbc:hsqldb:"+ databaseFile;            
            Class.forName( sDbDrv );  // erzeugen und 
            conn = DriverManager.getConnection( sDbUrl, sUsr, sPwd );
        } catch( SQLException e1 ) {
          System.out.println( e1 );
        }
        catch( ClassNotFoundException e2 ) {
          System.out.println( e2 );
        }
    }
    
    public Vector<String> getTables() {
        String TABLE_NAME = "TABLE_NAME";
        String TABLE_SCHEMA = "TABLE_SCHEM";
        String[] TABLE_TYPES = {"TABLE"};        
        
        Vector<String> tables = new Vector<String>();
        
          // Verbindung zur Datenbank, Auslese Variablen
        Statement  st = null;
        ResultSet  rs = null;

        try {
          DatabaseMetaData dbmd = conn.getMetaData();
          rs = dbmd.getTables(null, null, null, TABLE_TYPES);
          
         while (rs.next()) {
             // System.out.println(rs.getString(TABLE_NAME));
             // System.out.println(rs.getString(TABLE_SCHEMA));
            tables.add( rs.getString(TABLE_NAME) );
         }
    

        } catch( Exception ex ) {
          System.out.println( ex );
        } finally {
          try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
          try { if( null != st ) st.close(); } catch( Exception ex ) {}          
        }  
        return tables;
    }
    
    
    public Vector<TableColumns> getColumns(String tablename) {
        TableColumns tc;
        Vector<TableColumns> liste = new Vector<TableColumns>();
        String sql = "SELECT column_name, Data_type FROM INFORMATION_SCHEMA.COLUMNS\n" +
                    "where table_name='"+ tablename+"' ";
        DataTable dt1 = selectDBS(sql);
        ArrayList<ArrayList> tableRows = dt1.tableRows;
        ArrayList<String> tupels;            
        for (int row = 0; row < tableRows.size(); row++) {
            tupels = tableRows.get(row);
            tc = new TableColumns();
            tc.column_name = tupels.get(0);
            tc.data_type = tupels.get(1);
            liste.add(tc);
        }                
        return liste;        
    }
    
    
    
    
    
    public DataTable selectDBS(String sql) {
        DataTable dt=new DataTable();
        int i;
          // Verbindung zur Datenbank, Auslese Variablen
        Statement  st = null;
        ResultSet  rs = null;

        try {
          // Treiber INIT, Verbinden  und SQL-Statement auslösen
          st = conn.createStatement();
          
            // SQL-Statement          
          rs = st.executeQuery( sql );

          // Get meta data:
          ResultSetMetaData rsmd = rs.getMetaData();
          int anzCols = rsmd.getColumnCount();  // neue Felder
          dt.anzCools=anzCols;

            // Man braucht den Vektor headerNames, da jetzt noch nicht
           // alle Spalten vorhanden sind.
          for( i=0; i<anzCols; i++ ) {   // Attention: first column with 1 instead of 0
            dt.headerColums.add( rsmd.getColumnName( i+1 ) );
          }
            // Schleife über alle Tupel
          while( rs.next() ) {
              // neue Zeile
              // Zeile aller Daten
            ArrayList<String> tupel = new ArrayList<String>();
            for( i=0; i<anzCols; i++ ) { // Attention: first column with 1 instead of 0
              //String s=rs.getString( i+1 );
              tupel.add ( rs.getString( i+1 ) );
            }
              // Tupel zur Gesamtliste hinzufügen
            dt.tableRows.add( tupel );
            dt.anzRows = dt.tableRows.size();
          }


        } catch( Exception ex ) {
          System.out.println( ex );
        } finally {
          try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
          try { if( null != st ) st.close(); } catch( Exception ex ) {}
        }
        return dt;
    }
    
   
    public void changeDBS(String sql) {
        
        int i;
        Statement  st = null;
        ResultSet  rs = null;

        try {
          // Treiber INIT, Verbinden  und SQL-Statement auslösen
          st = conn.createStatement();          
            // SQL-Statement          
          st.execute( sql );
          // System.out.println("\n"+sql);
          
        } catch( Exception ex ) {
          System.out.println( ex );
        } finally {
          try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
          try { if( null != st ) st.close(); } catch( Exception ex ) {}
        }
    }
    
       public void shutdownDBS() {
        
        int i;
        Statement  st = null;
        ResultSet  rs = null;

        try {
          // Treiber INIT, Verbinden  und SQL-Statement auslösen
          st = conn.createStatement();          
          st.execute("SHUTDOWN");

        } catch( Exception ex ) {
          System.out.println( ex );
        } finally {
          try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
          try { if( null != st ) st.close(); } catch( Exception ex ) {}
        }
    }
    
    
}
