package hsql_bsp3;

import java.awt.*;
import javax.swing.*;

import java.awt.event.*;
import java.util.ArrayList;


public class FInsertUpdateAbteilung extends JDialog implements ActionListener{
    
  public boolean retcode=false;
  
  private ArrayList<ModelAbteilung> items = null;
  private ModelAbteilung abt=null;
  
  private JLabel lCaption = new JLabel("Eingabe einer neuen Abteilung");
  private JLabel jLabel1 = new JLabel("KurzBez");
  private JTextField tkurzBez = new JTextField();
  private JLabel jLabel2 = new JLabel("Bezeichnung");
  private JTextField tbez = new JTextField();

  private JButton bnOk = new JButton("Ok");
  private JButton bnEsc = new JButton("Abbrechen");
  
  
  public String getKurzBez() {
    return tkurzBez.getText().trim(); 
  }
  public String getBez() {
    return tbez.getText().trim(); 
  }
  
  public FInsertUpdateAbteilung(Frame parent, ArrayList<ModelAbteilung> items, ModelAbteilung abt) {
    super(parent);
    setModal(true);
    setSize(400, 250);
    setTitle("Eingabe einer neuen Abteilung");
    this.items = items;
    this.abt = abt;
    // setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    setGUI();
    if (abt!=null) {
        tkurzBez.setText(abt.getKurzBez());
        tbez.setText(abt.getBez());
        setTitle("Bearbeiten einer vorhanden Abteilung");
        lCaption.setText( "Bearbeiten einer vorhanden Abteilung" );
    }
    setVisible(true);
  }

  private void setGUI() {
    this.getContentPane().setLayout( new GridBagLayout() );

    jLabel1.setFont( new Font("Arial", Font.BOLD,14)  );
    tkurzBez.setFont( new Font("Arial", Font.BOLD,14)  );
    jLabel2.setFont( new Font("Arial", Font.BOLD,14)  );
    tbez.setFont( new Font("Arial", Font.BOLD,14)  );

    bnOk.setFont( new Font("Arial", Font.BOLD,14)  );
    bnEsc.setFont( new Font("Arial", Font.BOLD,14)  );

    
    lCaption.setFont( new Font("Arial", Font.BOLD,18)  );
    lCaption.setForeground(Color.BLUE);
    
    this.getContentPane().add(lCaption,
         new GridBagConstraints(
             0, 0, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST,
            GridBagConstraints.NONE,
            new Insets(20,20,20,0), 0, 0));
    
    this.getContentPane().add(jLabel1,
         new GridBagConstraints(
             0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST,
            GridBagConstraints.NONE,
            new Insets(10,20,0,0), 0, 0));

    this.getContentPane().add(tkurzBez,
        new GridBagConstraints(
               1, 1, 1, 1, 80.0, 0.0
            ,GridBagConstraints.WEST,
            GridBagConstraints.HORIZONTAL,
            new Insets(10,20,0,20), 0, 0));


    this.getContentPane().add(jLabel2,
         new GridBagConstraints(
             0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST,
            GridBagConstraints.NONE,
            new Insets(20,20,0,0), 0, 0));

    this.getContentPane().add(tbez,
        new GridBagConstraints(
             1, 2, 1, 1, 80.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(20,20,0,20), 0, 0));

    JPanel pn = new JPanel();
    pn.add(bnOk);
    pn.add(bnEsc);
    this.getContentPane().add(pn,
           new GridBagConstraints(
             0, 3, 2, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(20,0,20,0), 0, 0));

    bnOk.addActionListener(this);
    bnEsc.addActionListener(this);
  }  // setGUI
  
  

    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getSource()==bnEsc) {
            this.dispose();
        }
        if (e.getSource()==bnOk) {
            bnOk_click();
        }
    } // actionPerformed
    
    private void bnOk_click() {
       String kurzbez = tkurzBez.getText().trim(); 
       String bez = tbez.getText().trim(); 
       
       if (kurzbez.length()==0) {
           Basis.Message("Eingabe einer neuen Abteilung", "Bitte geben Sie eine Kurzbezeichnung ein");
           return;
       }
       if (bez.length()==0) {
           Basis.Message("Eingabe einer neuen Abteilung", "Bitte geben Sie eine Bezeichnung ein");           
           return;
       }
       if (abt==null) {
        for (ModelAbteilung abt :items) {
            if (abt.getKurzBez().equals(kurzbez)) {
                Basis.Message("Eingabe einer neuen Abteilung", "Die Abteilung ist schon vorhanden");                          
                return;              
            }
        }       
       }
       retcode=true;
       this.dispose();
    } 

  
}
