package hsql_bsp3;


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;


public class FShowAbteilungen1 extends JDialog  implements ActionListener{
    
    private final JMenuItem mnClose = new JMenuItem("Schließen");
    private final JMenuItem mnExport2Excel = new JMenuItem("Export nach Excel");
   
    
    private MyTableModelAbteilungen1 table;
    
    public FShowAbteilungen1(Frame parent) {
       super(parent);
       
        setModal(true);
        setTitle("Abteilungs-Dialog (1)");
        setSize(800,250);
        
        setGUI();
        setMenues();
        setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
        setVisible(true);
    }
    
    private void setGUI() {
      table = new MyTableModelAbteilungen1();
      setLayout( new BorderLayout() );
    
      this.getContentPane().add(table, BorderLayout.CENTER);
      table.setFont(new Font("Arial", Font.BOLD, 16));
      
        this.addWindowListener(new java.awt.event.WindowAdapter() {

          public void windowActivated(WindowEvent e) {
            //this_windowActivated(e);
          }

          public void windowClosed(WindowEvent e) {
            //this_windowClosed(e);
          }

          public void windowClosing(WindowEvent e) {
            this_windowClosing(e);
          }

          public void windowDeactivated(WindowEvent e) {
            //this_windowDeactivated(e);
          }

          public void windowDeiconified(WindowEvent e) {
            //this_windowDeiconified(e);
          }

          public void windowIconified(WindowEvent e) {
            //this_windowIconified(e);
          }

          public void windowOpened(WindowEvent e) {
            // this_windowOpened(e);
          }
        });
      
    }    // setGUI
    
    
    
    
    private void setMenues() {
        JMenu mainFile = new JMenu("Datei");
        
        mainFile.add(mnClose);
        
        JMenu mainExport = new JMenu("Export");
        mainExport.add(mnExport2Excel);
        

        JMenuBar menuBar1 = new JMenuBar();
        menuBar1.add(mainFile);
        menuBar1.add(mainExport);
        this.setJMenuBar(menuBar1);
        
        mnClose.addActionListener(this);
        mnExport2Excel.addActionListener(this);
                
        for (int i = 0; i < menuBar1.getComponentCount(); i++) {
              JMenu main = (JMenu) menuBar1.getComponent(i);
              main.setFont(new Font("Arial", Font.BOLD, 14));
              for (int j = 0; j < main.getItemCount(); j++) {
                Component c = main.getItem(j);
                if (c instanceof JMenuItem) {
                  JMenuItem mn = (JMenuItem) c;
                  mn.setFont(new Font("Arial", Font.BOLD, 14));
                }
              }
        }        
    } // setMenues    
    
    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getSource()==mnClose) {
            this.dispose();
        }     
        if (e.getSource()==mnExport2Excel) {
            mnExport2Excel_click();
        } 
    }  // actionPerformed
        
    private void mnExport2Excel_click() {
        JFileChooser jFileChooser1 = new JFileChooser();
          // setzen der Optionen
        jFileChooser1.setMultiSelectionEnabled(false);
        jFileChooser1.setCurrentDirectory(  new File(  (String) System.getProperties().get("user.dir")  )   );

           // Aufruf des Dialogfensters
         if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
             // holen des Dateinamens
            table.saveTable2Excel(jFileChooser1.getSelectedFile().getPath() );
            StartExcel(jFileChooser1.getSelectedFile().getPath());        
         }                
    }
    
    
    private void StartExcel(String filename) {
        String excel = "\"C:\\Program Files (x86)\\Microsoft Office\\Office14\\EXCEL.EXE\"";

        try {
          // funktioniert nur mit vollstaendigen Pfad
          Runtime.getRuntime().exec( excel+" "+filename);
        }
        catch (IOException e) {
           System.out.println("Error in Start Excel");
        }
    } // StartExcel
    
    public void this_windowClosing(WindowEvent e) {        
        if (table.getModify()) {
            int i = Basis.YesNoEsc( "Dialog beenden","Sollen die Änderungen gespeichert werden?");
            switch (i) {
                case Basis.YES: table.save2Database();  break;
                case Basis.NO: break;
                case Basis.ESC: return;
            }
        }
        this.dispose();
    }
        
    
}
