﻿


import javax.swing.*;

import java.awt.Dimension;
import java.awt.event.*;

import java.awt.*;


import java.sql.*;


// schalter
import java.awt.event.*;
import java.io.File;

public class Hsql_Bsp3 extends JFrame implements ActionListener {
    
  private static final String PREFERRED_LOOK_AND_FEEL = "com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel";
    
    
    String db_filedir="dbs\\hsqldb_bsp";

    JToolBar toolbar = new JToolBar();

    private final JMenuItem mnCreateDBFile = new JMenuItem("Datenbank erstellen");
    private final JMenuItem mnClose = new JMenuItem("Schließen");
    
    private final JMenuItem mnStartAbteilungen1 = new JMenuItem("Abteilungen (1)");
    private final JMenuItem mnStartMitarbeiter1 = new JMenuItem("Mitarbeiter (1)");
    private final JMenuItem mnStartAbteilungen2 = new JMenuItem("Abteilungen (2)");
    private final JMenuItem mnStartMitarbeiter2 = new JMenuItem("Mitarbeiter (2)");
    private final JMenuItem mnDBS_Console = new JMenuItem("Datenbank Konsole");

    private final JButton bnOpenDBFile = new JButton("Datenbank öffnen");
    private final JButton bnStartAbteilungen1 = new JButton("Abteilungen (1)");
    private final JButton bnStartMitarbeiter1 = new JButton("Mitarbeiter (1)");
    private final JButton bnStartAbteilungen2 = new JButton("Abteilungen (2)");
    private final JButton bnStartMitarbeiter2 = new JButton("Mitarbeiter (2)");
        

        /** Creates a new instance of Main */
    public Hsql_Bsp3() {
        setSize(650,200);
        setLocation(10,10);
        setTitle("Mitarbeiter Abteilung");
        setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        setGUI();
        CheckCanExecuted(false);            
        
        File file = new File(db_filedir+".script");
        if (file.exists()) {
            bnOpenDBFile.setEnabled(true);
        }

        
        this.paintAll(this.getGraphics());
        setVisible(true);
    }
    
    private void setGUI() {
        setLayout(new BorderLayout());
        setMenues();
        setToolBars();
    }  // setGUI

    
      private void CheckCanExecuted(boolean enabled) {          
          mnStartAbteilungen1.setEnabled(enabled);
          mnStartAbteilungen2.setEnabled(enabled);
          mnStartMitarbeiter1.setEnabled(enabled);
          mnStartMitarbeiter2.setEnabled(enabled);
          bnStartMitarbeiter1.setEnabled(enabled);
          bnStartMitarbeiter2.setEnabled(enabled);
          mnDBS_Console.setEnabled(enabled);
          bnStartAbteilungen1.setEnabled(enabled);
          bnStartAbteilungen2.setEnabled(enabled);
          bnOpenDBFile.setEnabled(enabled);
      }
    
    
    private void setMenues() {
        JMenu mainFile = new JMenu("Datei");
        
        mainFile.add(mnCreateDBFile);
        mainFile.addSeparator();
        mainFile.add(mnClose);
        
        
        JMenu mainDialogs = new JMenu("Dialoge");
        mainDialogs.add(mnStartAbteilungen1);
        mainDialogs.add(mnStartMitarbeiter1);
        mainFile.addSeparator();
        mainDialogs.add(mnStartAbteilungen2);
        mainDialogs.add(mnStartMitarbeiter2);
        mnStartAbteilungen1.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F5, 0));
        mnStartMitarbeiter1.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F6, 0));
        
        JMenu  mainDBS = new JMenu("Datenbank");
        mainDBS.add(mnDBS_Console);
        
        JMenuBar menuBar1 = new JMenuBar();
        menuBar1.add(mainFile);
        menuBar1.add(mainDialogs);
        menuBar1.add(mainDBS);
        this.setJMenuBar(menuBar1);
                
        mnCreateDBFile.addActionListener(this);
        mnClose.addActionListener(this);
        mnStartAbteilungen1.addActionListener(this);
        mnStartMitarbeiter1.addActionListener(this);
        mnDBS_Console.addActionListener(this);
                
        for (int i = 0; i < menuBar1.getComponentCount(); i++) {
              JMenu main = (JMenu) menuBar1.getComponent(i);
              main.setFont(new Font("Arial", Font.BOLD, 16));
              for (int j = 0; j < main.getItemCount(); j++) {
                Component c = main.getItem(j);
                if (c instanceof JMenuItem) {
                  JMenuItem mn = (JMenuItem) c;
                  mn.setFont(new Font("Arial", Font.BOLD, 16));
                }
              }
        }        
    } // setMenues
    
    
  private void setToolBars() {
    JToolBar toolBar = new JToolBar();

    toolBar.add(bnOpenDBFile);
    toolBar.add(bnStartAbteilungen1);
    toolBar.add(bnStartMitarbeiter1);
    toolBar.add(bnStartAbteilungen2);
    toolBar.add(bnStartMitarbeiter2);
    bnOpenDBFile.addActionListener(this);    
    bnStartAbteilungen1.addActionListener(this);   
    bnStartMitarbeiter1.addActionListener(this);   
    bnStartAbteilungen2.addActionListener(this);   
    bnStartMitarbeiter2.addActionListener(this);   
    
    bnOpenDBFile.setFont(new Font("Arial", Font.BOLD, 14));
    bnStartAbteilungen1.setFont(new Font("Arial", Font.BOLD, 14));
    bnStartMitarbeiter1.setFont(new Font("Arial", Font.BOLD, 14));
    bnStartAbteilungen2.setFont(new Font("Arial", Font.BOLD, 14));
    bnStartMitarbeiter2.setFont(new Font("Arial", Font.BOLD, 14));
    
    this.getContentPane().add(toolBar, BorderLayout.NORTH);
  } // setToolBars
  
    
    private  void installLnF() {
        try {
          String lnfClassname = PREFERRED_LOOK_AND_FEEL;
          if (lnfClassname == null)
            lnfClassname = UIManager.getCrossPlatformLookAndFeelClassName();
          UIManager.setLookAndFeel(lnfClassname);
        } catch (Exception e) {
          System.err.println("Cannot install " + PREFERRED_LOOK_AND_FEEL + " on this platform:" + e.getMessage());
        }
      }    



    @Override
    public void actionPerformed(ActionEvent e) {        
        if (e.getSource()==mnCreateDBFile) {
            mnCreateDBFile_click();            
        }
        if (e.getSource()==bnOpenDBFile) {
            mnOpenDBFile_click();
        }
        
        if (e.getSource()==mnClose) {
            this.dispose();      
        } 
        if ( (e.getSource()==mnStartAbteilungen1) || (e.getSource()==bnStartAbteilungen1)) {
            showAbteilungen1_Click();   
        } 
        if ( (e.getSource()==mnStartAbteilungen2) || (e.getSource()==bnStartAbteilungen2)) {
            showAbteilungen2_Click();   
        } 
        if ( (e.getSource()==mnStartMitarbeiter1) || (e.getSource()==bnStartMitarbeiter1)) {
            showMitarbeiter1_Click();   
        } 
        if ( (e.getSource()==mnStartMitarbeiter2) || (e.getSource()==bnStartMitarbeiter2)) {
           // showMitarbeiter2_Click();   
        } 
        if (e.getSource()==mnDBS_Console) {
            mnDBS_Console_Click();
        }     
    }
    
private void deleteFiles(String filename) {
      File file;
      file = new File(filename+".lck");
      if (file.exists()) file.delete();

      file = new File(filename+".log");
      if (file.exists()) file.delete();
      file = new File(filename+".properties");
      if (file.exists()) file.delete();
      file = new File(filename+".script");
      if (file.exists()) file.delete();
  }
    

    void mnCreateDBFile_click() {
      if (Basis.YesNo("Datenbank erstellen", "Wollen Sie wirklich eine neue Datenbank erstellen?")) {
        deleteFiles(db_filedir);
        setTitle("Firma: " + Basis.getFilenameExt(db_filedir));
        Dbs dbs = Dbs.getDbsInstance();            
        dbs.setDbs(db_filedir);
        insertTables();
        CheckCanExecuted(true);
        Basis.Message("Erstellen der Datenbank", "Die Datenbank wurde erstellt");
      }
  }    
 
   private void insertTables() {
       String sqlLines = Basis.readLines("hsqldb_mitarbeiter_abteilung.txt");
       String[] sqlParts = sqlLines.split(";");
       Dbs dbs = Dbs.getDbsInstance();            
       for (String sql : sqlParts) {
           sql=sql.trim();
           if (sql.length()>0) {
            // System.out.println(sql);
             String sqllower = sql.toLowerCase();
             if (sqllower.contains("create") || sqllower.contains("insert") || sqllower.contains("alter table") || sqllower.contains("update"))
                 dbs.changeDBS(sql);                
             else
                 dbs.selectDBS(sql);
           }
       }
   }
 
 

  
  
  void mnOpenDBFile_click() {
        setTitle("Firma: " + Basis.getFilenameExt(db_filedir));
        Dbs dbs = Dbs.getDbsInstance();            
        dbs.setDbs(db_filedir);
        CheckCanExecuted(true);            
  }  // mnOpen
        

    private void mnDBS_Console_Click() {
        new FDBSConsole(this);
    }

    private void showAbteilungen1_Click(){
        new FShowAbteilungen1(this);
    }
    private void showAbteilungen2_Click(){
        // new FShowAbteilungen2(this);
    }

    private void showMitarbeiter1_Click(){
        new FShowMitarbeiter1(this);
    }
    private void showMitarbeiter2_Click(){
        // new FShowMitarbeiter2(this);
    }
    
    public static void main(String[] args) {
       Hsql_Bsp3 frame = new Hsql_Bsp3();
       frame.setVisible(true);
    }

    
}
