package hsql_bsp3;

 import java.util.ArrayList;

public class ModelMitarbeiter extends ModelBase{
   
        public static String SQL =
                "SELECT pindex, vorname, nachname, gehaltmonat, aindex FROM Mitarbeiter ORDER BY nachname;";
    
        private long pindex;
        private String vorname;
        private String nachname;
        private double gehaltmonat;
        private double gehaltjahr;
        private long aindex;
        

        public void splitSQL(ArrayList tupels) {
           pindex = Integer.parseInt((String)tupels.get(0));
           vorname = (String) tupels.get(1);
           nachname = (String) tupels.get(2);           
           gehaltmonat = Double.parseDouble((String)tupels.get(3));
           gehaltjahr=gehaltmonat*12;
           aindex = Long.parseLong((String)tupels.get(4));
        }
        
        public static int getColumnCount() {
            return 6;
        }
        
        public static String getColumn(int col) {
            switch (col) {
                case 0: return "Vorname"; 
                case 1: return "Nachname"; 
                case 2: return "Monatsgehalt"; 
                case 3: return "Jahresgehalt"; 
                case 4: return "PIndex"; 
                case 5: return "AIndex"; 
                default: return "Fehler in switch/case in Modul ModelMitarbeiter";
            }
        }
        public Object getValue(int col) {
            switch (col) {
                case 0: return vorname; 
                case 1: return nachname; 
                case 2: return gehaltmonat;
                case 3: return gehaltjahr;
                case 4: return pindex; 
                case 5: return aindex; 
                default: return "Fehler in switch/case in Modul getValue";
            }
        }
        public void setValue(Object aValue, int col) {
            switch( col ) {
                case 0: setVorname( (String) aValue);
                        break;
                case 1: setNachname( (String) aValue);
                        break;
                case 2: String sGehalt = (String) aValue;
                        if (Basis.DVal(sGehalt)) {
                           gehaltmonat = Basis.dblVal; 
                           gehaltjahr = gehaltmonat*12;
                        }
                        break;
                case 5: String s = (String) aValue;
                        if (Basis.LVal(s)) {
                            aindex=Basis.longVal;
                        }
                default: Basis.ErrorMsg("Fehler", "Fehler in setValue, column: "+col);
            }
        }
        
        
        public ModelMitarbeiter() {
            this(-1,"","",0,0);
        }

        public ModelMitarbeiter(long pindex, String vorname, String nachname, 
                double monatsgehalt, long aindex) {
            setPIndex(pindex);
            setVorname(vorname);
            setNachname(nachname);
            setGehaltMonat(monatsgehalt);
            setAIndex(aindex);
        }
        
        public String getVorname() {
            return vorname; 
        }
        public String getVornameQuote() {
            return "'"+vorname+"'"; 
        }
        public void setVorname(String value) {
            if (value != vorname) {
                modify = true;
                vorname = value;
            }
        }

        public String getNachname() {
            return nachname; 
        }
        public String getNachnameQuote() {
            return "'"+nachname+"'"; 
        }
        public void setNachname(String value) {
            if (value != nachname) {
                modify = true;
                nachname = value;
            }
        }
        
        public double getGehaltMonat() {
            return gehaltmonat; 
        }
        public void setGehaltMonat(double value) {
            if (value != gehaltmonat) {
                modify = true;
                gehaltmonat = value;
                gehaltjahr = value*12;
            }
        }
       
        
        public double getGehaltJahr() {
            return gehaltjahr; 
        }
        public void setGehaltJahr(double value) {
            if (value != gehaltjahr) {
                modify = true;
                gehaltjahr = value;
            }
        }
       

        public long getPIndex() {
            return pindex; 
        }
        public void setPIndex(long pindex) {
            if (this.pindex != pindex) {
                modify = true;
                this.pindex = pindex;
            }
        }

        public long getAIndex() {
            return aindex; 
        }
        public void setAIndex(long aindex) {
            if (this.aindex != aindex) {
                modify = true;
                this.aindex = aindex;
            }
        }
       
         public int compareTo(Object obj) {
             return 0;
         }
        

        @Override
        public  String toString() {
            return vorname + "   " + nachname+"   Gehalt: "+gehaltmonat;
        }    
    
}
