﻿

import javax.swing.*;

import java.awt.Dimension;
import java.awt.event.*;

import java.awt.*;
import java.util.ArrayList;
import javax.swing.table.*;


public class MyTableModelAbteilungen1 extends JPanel implements ActionListener{
    
    private JLabel lbAnzahl = new JLabel("0");
    
    private final JButton bnFirst = new JButton("Erster", new ImageIcon("first.png"));
    private final JButton bnPrev = new JButton("Vorheriger", new ImageIcon("prev.png"));
    private final JButton bnNext = new JButton("Nächster", new ImageIcon("next.png"));
    private final JButton bnLast = new JButton("Letzter", new ImageIcon("last.png"));
    private final JButton bnDelete = new JButton("Löschen", new ImageIcon("delete.png"));
    private final JButton bnInsert = new JButton("Einfügen", new ImageIcon("plus.png"));
    
    private ArrayList<ModelAbteilung> items = new ArrayList<ModelAbteilung>();
    private ArrayList<ModelAbteilung> deleteItems = new ArrayList<ModelAbteilung>();
    
    private JTable table = new JTable();
    
    public MyTableModelAbteilungen1() {
        setGUI();        
        setTables();
        table.setAutoCreateRowSorter(true);
    }
    
    private void setGUI() {
        setLayout( new BorderLayout());
        add(new JScrollPane(table), BorderLayout.CENTER);
        table.setFont( new Font("Arial", Font.BOLD,14)  );
        setToolBars();
        table.addMouseListener(new java.awt.event.MouseAdapter() {
          public void mouseClicked(MouseEvent e) {
            tabelle_mouseClicked(e);
          }
        });
    }
    
 private void setToolBars() {
    JToolBar toolBar = new JToolBar();

    toolBar.add(lbAnzahl);
    toolBar.addSeparator( new Dimension(20,10) );
    toolBar.add(bnFirst);
    toolBar.addSeparator( new Dimension(5,10) );
    toolBar.add(bnPrev);
    toolBar.addSeparator( new Dimension(5,10) );
    toolBar.add(bnNext);
    toolBar.addSeparator( new Dimension(5,10) );
    toolBar.add(bnLast);
    toolBar.addSeparator( new Dimension(20,10) );
    toolBar.add(bnDelete);
    toolBar.addSeparator( new Dimension(5,10) );
    toolBar.add(bnInsert);
    bnFirst.addActionListener(this);
    bnPrev.addActionListener(this);
    bnNext.addActionListener(this);
    bnLast.addActionListener(this);
    bnInsert.addActionListener(this);
    bnDelete.addActionListener(this);    
    
    this.add(toolBar, BorderLayout.NORTH);
  } // setToolBars
    
    @Override
    public void actionPerformed(ActionEvent e) {        
        if (e.getSource()==bnFirst) {
            bnFirst_click();            
        }
        if (e.getSource()==bnPrev) {
            bnPrev_click();
        }
        if (e.getSource()==bnNext) {
            bnNext_click();            
        }
        if (e.getSource()==bnLast) {
            bnLast_click();
        }
        if (e.getSource()==bnInsert) {
            bnInsert_click();            
        }
        if (e.getSource()==bnDelete) {
            bnDelete_click();
        }
    }
    
    private void selectAndScroll(int row) {
        Rectangle cellRect = table.getCellRect(row, 0, true);
        table.scrollRectToVisible(cellRect);

        table.clearSelection();
        table.setRowSelectionInterval(row, row);        
    }  
  

    private void bnFirst_click() {
        selectAndScroll(0);
    }
    
    private void  bnPrev_click() {
        int row = table.getSelectedRow();
        if (row>0) {
            selectAndScroll(row-1);
        }
    }
    
    private void bnNext_click() {
        int row = table.getSelectedRow();
        if (row<(items.size()-1)) {
            selectAndScroll(row+1);
        }
    }
    private void bnLast_click() {
        int row = table.getSelectedRow();
        if (row<(items.size())) {
            selectAndScroll(items.size()-1);
        }
    }
    
    private void bnInsert_click() {
        FInsertUpdateAbteilung dialog = new FInsertUpdateAbteilung(null, items, null);
        if (dialog.retcode) {
           String kurzbez = dialog.getKurzBez();
           String bez = dialog.getBez();
           Dbs dbs = Dbs.getDbsInstance();            
           long pindex = dbs.getSequenz("seq");
           ModelAbteilung abt = new ModelAbteilung(pindex, kurzbez, bez);
           items.add(abt);
           table.setModel( createTableModel() );
           table.updateUI();
           setItemsCount();
        }
    }
    private void bnDelete_click() {
        int index = table.getSelectedRow();
        if (index>=0) {
            ModelAbteilung abt = items.get(index);
            if (Basis.YesNo("Löschen einer Abteilung",
                    "Wollen Sie wirklich diese Abteilung löschen?\n"+
                            "Abteilung: "+abt.toString())) {
                items.remove(abt);
                deleteItems.add(abt);   
                table.setModel( createTableModel() );
                table.updateUI();
                setItemsCount();
            }
        }        
    }  // bnDelete_click
    
    private void editAbteilung() {
        int index = table.getSelectedRow();
        if (index>=0) {
            ModelAbteilung abt = items.get(index);
            FInsertUpdateAbteilung dialog = new FInsertUpdateAbteilung(null, items, abt);
            if (dialog.retcode) {
               String kurzbez = dialog.getKurzBez();
               String bez = dialog.getBez();
               abt.setKurzBez(kurzbez);
               abt.setBez(bez);
               //items.add(abt);
                table.setModel( createTableModel() );
                table.updateUI();
            }
        }        
    }  // editAbteilung
    
    
  void tabelle_mouseClicked(MouseEvent e) {
        // linke Maustaste?
      
        if (  Basis.getButton(e) == 1) {
           if ( e.getClickCount() == 2) {            
            editAbteilung();
           }
           if ( e.getClickCount() == 1) {
            
           }
         }
          // rechte Maustaste
        if (  Basis.getButton(e) == 3) {
            
         }

      }
    
    
    private void setTables() {
        items = Mapping.selectModelAbteilung();
        table.setModel( createTableModel() );
        setItemsCount();
    }
    private void setItemsCount() {
        lbAnzahl.setText("Anz: "+items.size());
    }
    
        
    private TableModel createTableModel() {
        TableModel dataModel = new AbstractTableModel() {
            public int getColumnCount() {
                return ModelAbteilung.getColumnCount();
            }
            public int getRowCount() {
                if (items.size()==0)
                    return 1;
                else 
                    return items.size();
            }
            public String getColumnName(int col) {
                return ModelAbteilung.getColumn(col);
            }

            public Object getValueAt(int row, int col) {
                if (items.size()==0)
                    return "leer";
                else {
                    ModelAbteilung abt = items.get(row);
                    return abt.getValue(col);
                }
            }
            
            public boolean isCellEditable(int row, int col) {
              return col!=2;
            }
            public void setValueAt(Object aValue, int row, int col) {
              ModelAbteilung  abt = items.get(row);
              abt.setValue(aValue, col);
            }

         };
        
        return dataModel;
    }  // createDataModel
        
    
    public void saveTable2Excel( String filename ) {
        Export2BIFF excel = new Export2BIFF( filename );
        excel.openFile();
        int ncols=ModelAbteilung.getColumnCount();
        for (int col=0; col<ncols; col++) {            
            excel.Write(col,0, ModelAbteilung.getColumn(col) );  // col row Value
        }
        for (int row=0; row<items.size(); row++) {
            ModelAbteilung abt = items.get(row);                                
            for (int col=0; col<ncols; col++) {
                excel.Write(col,row+1, abt.getValue(col) );  // col row Value
            }                    
        }
        excel.closeFile();
        
    }  // saveTable2Excel

    public boolean getModify() {
        boolean modify=false;
        for (ModelAbteilung abt : items) {
            if (abt.modify) modify=true;
            if (abt.neu) modify=true;
        }
        return modify;
    }
    
    /*
    insert into Abteilung(pindex, kurzbez, bez)
         Values(4, 'WARTG' , 'Wartung');
    UPDATE Abteilung
    SET kurzbez='xxx', bez='yyy'
    WHERE pindex=12345;
    DELETE FROM Abteilung WHERE pindex=12345;
    */
    public void save2Database() {
        Dbs dbs = Dbs.getDbsInstance();            
        String sql;
        for (ModelAbteilung abt: deleteItems) {
            sql = "DELETE FROM Abteilung WHERE pindex="+abt.getPIndex()+";";
            dbs.changeDBS(sql);
        }        
        for (ModelAbteilung abt : items) {
            if (abt.neu) {
                sql = "INSERT INTO Abteilung(pindex, kurzbez, bez) "+
                        "Values ("+abt.getPIndex()+", "+abt.getKurzBezQuote()+", "+abt.getBezQuote()+");";
                dbs.changeDBS(sql);
            }
            else {
                if (abt.modify) {
                   sql= "UPDATE Abteilung "+
                        " SET kurzbez="+abt.getKurzBezQuote()+", bez="+abt.getBezQuote()+" "+
                        " WHERE pindex="+abt.getPIndex()+";";
                   dbs.changeDBS(sql);
                }
            }
        }
        dbs.shutdownDBS();
        dbs.openDbs();
    } // save2Database
    
}
