﻿

import javax.swing.*;

import java.awt.Dimension;
import java.awt.event.*;

import java.awt.*;
import java.util.ArrayList;
import javax.swing.table.*;

public class MyTableModelMitarbeiter1 extends JPanel implements ActionListener{

    private JLabel lbAnzahl = new JLabel("0");
    
    private final JButton bnFirst = new JButton("Erster", new ImageIcon("first.png"));
    private final JButton bnPrev = new JButton("Vorheriger", new ImageIcon("prev.png"));
    private final JButton bnNext = new JButton("Nächster", new ImageIcon("next.png"));
    private final JButton bnLast = new JButton("Letzter", new ImageIcon("last.png"));
    // private final JButton bnEdit = new JButton("Bearbeiten", new ImageIcon("edit.png"));
    private final JButton bnDelete = new JButton("Löschen", new ImageIcon("delete.png"));
    private final JButton bnInsert = new JButton("Einfügen", new ImageIcon("plus.png"));
    
    private ArrayList<ModelMitarbeiter> items = new ArrayList<ModelMitarbeiter>();
    private ArrayList<ModelMitarbeiter> deleteItems = new ArrayList<ModelMitarbeiter>();
    
    private JTable table = new JTable();
    
    public MyTableModelMitarbeiter1() {
        setGUI();        
        setTables();
        table.setAutoCreateRowSorter(true);
    }
    
    private void setGUI() {
        setLayout( new BorderLayout());
        add(new JScrollPane(table), BorderLayout.CENTER);
        table.setFont( new Font("Arial", Font.BOLD,14)  );
        setToolBars();
    }
    
 private void setToolBars() {
    JToolBar toolBar = new JToolBar();

    toolBar.add(lbAnzahl);
    toolBar.addSeparator( new Dimension(20,10) );

    toolBar.add(bnFirst);
    toolBar.addSeparator( new Dimension(5,10) );
    toolBar.add(bnPrev);
    toolBar.addSeparator( new Dimension(5,10) );
    toolBar.add(bnNext);
    toolBar.addSeparator( new Dimension(5,10) );
    toolBar.add(bnLast);
    toolBar.addSeparator( new Dimension(20,10) );
    toolBar.add(bnDelete);
    toolBar.addSeparator( new Dimension(5,10) );
    toolBar.add(bnInsert);
    bnFirst.addActionListener(this);
    bnPrev.addActionListener(this);
    bnNext.addActionListener(this);
    bnLast.addActionListener(this);
    bnInsert.addActionListener(this);
    bnDelete.addActionListener(this);    
    
    this.add(toolBar, BorderLayout.NORTH);
  } // setToolBars
    
    @Override
    public void actionPerformed(ActionEvent e) {        
        if (e.getSource()==bnFirst) {
            bnFirst_click();            
        }
        if (e.getSource()==bnPrev) {
            bnPrev_click();
        }
        if (e.getSource()==bnNext) {
            bnNext_click();            
        }
        if (e.getSource()==bnLast) {
            bnLast_click();
        }
        if (e.getSource()==bnInsert) {
            bnInsert_click();            
        }
        if (e.getSource()==bnDelete) {
            bnDelete_click();
        }
    }
 
    
    private void selectAndScroll(int row) {
        Rectangle cellRect = table.getCellRect(row, 0, true);
        table.scrollRectToVisible(cellRect);

        table.clearSelection();
        table.setRowSelectionInterval(row, row);        
    }    
    
    private void bnFirst_click() {
        selectAndScroll(0);
    }
    
    private void  bnPrev_click() {
        int row = table.getSelectedRow();
        if (row>0) {
            selectAndScroll(row-1);
        }
    }
    
    private void bnNext_click() {
        int row = table.getSelectedRow();
        if (row<(items.size()-1)) {
            selectAndScroll(row+1);
        }
    }
    private void bnLast_click() {
        int row = table.getSelectedRow();
        if (row<(items.size())) {
            selectAndScroll(items.size()-1);
        }
    }
    
    private void bnInsert_click() {
        FInsertUpdateMitarbeiter dialog = new FInsertUpdateMitarbeiter(null, items, null);
        if (dialog.retcode) {
           String vname = dialog.getVorname();
           String nname = dialog.getNachname();
           double monatsgehalt = dialog.getMonatsgehalt();
           long aindex = dialog.getAIndex();
           Dbs dbs = Dbs.getDbsInstance();            
           long pindex = dbs.getSequenz("seq");           
           ModelMitarbeiter mit = new ModelMitarbeiter(pindex, vname, nname, monatsgehalt, aindex);           
           items.add(mit);
           table.setModel( createTableModel() );
           table.updateUI();
        }
    }
    private void bnDelete_click() {
        int index = table.getSelectedRow();
        if (index>=0) {
            ModelMitarbeiter mit = items.get(index);
            if (Basis.YesNo("Löschen einer Abteilung",
                    "Wollen Sie wirklich diesen Mitarbeiter löschen?\n"+
                            "Mitarbeiter: "+mit.toString())) {
                items.remove(mit);
                deleteItems.add(mit);   
                table.setModel( createTableModel() );
                table.updateUI();
                setItemsCount();
            }
        }
        
    }
    
    
    private void setTables() {
        items = Mapping.selectModelMitarbeiter();
        table.setModel( createTableModel() );
        setItemsCount();
    }
    private void setItemsCount() {
        lbAnzahl.setText("Anz: "+items.size());
    }
    
        
    private TableModel createTableModel() {
        TableModel dataModel = new AbstractTableModel() {
            public int getColumnCount() {
                return ModelMitarbeiter.getColumnCount();
            }
            public String getColumnName(int col) {
                return ModelMitarbeiter.getColumn(col);
            }
            
            public int getRowCount() {
                if (items.size()==0)
                    return 1;
                else 
                    return items.size();
            }

            public Object getValueAt(int row, int col) {
                if (items.size()==0)
                    return "leer";
                else {
                    ModelMitarbeiter mit = items.get(row);
                    return mit.getValue(col);
                }
            }

            
            public boolean isCellEditable(int row, int col) {
                // gehaltjahr  PIndex
              return col!=3 && col!=4;
            }
            public void setValueAt(Object aValue, int row, int col) {
              ModelMitarbeiter  mit = items.get(row);
              mit.setValue(aValue, col);
            }            
            
         };
        
        return dataModel;
    }  // createDataModel
        
    
    public void saveTable2Excel( String filename ) {
        Export2BIFF excel = new Export2BIFF( filename );
        excel.openFile();
        int ncols=ModelMitarbeiter.getColumnCount();
        for (int col=0; col<ncols; col++) {            
            excel.Write(col,0, ModelMitarbeiter.getColumn(col) );  // col row Value
        }
        for (int row=0; row<items.size(); row++) {
            ModelMitarbeiter mit = items.get(row);                                
            for (int col=0; col<ncols; col++) {
                excel.Write(col,row+1, mit.getValue(col) );  // col row Value
            }                    
        }
        excel.closeFile();        
    }  // saveTable2Excel
    
    public void Delete(ModelMitarbeiter item) {
        items.remove(item);
        deleteItems.add(item);
    }


    public boolean getModify() {
        boolean modify=false;
        for (ModelMitarbeiter mit : items) {
            if (mit.modify) modify=true;
            if (mit.neu) modify=true;
        }
        return modify;
    }
    

       /*
    insert into Abteilung(pindex, kurzbez, bez)
         Values(4, 'WARTG' , 'Wartung');
    UPDATE Abteilung
    SET kurzbez='xxx', bez='yyy'
    WHERE pindex=12345;
    DELETE FROM Abteilung WHERE pindex=12345;
    */
    public void save2Database() {
        Dbs dbs = Dbs.getDbsInstance();            
        String sql;
        for (ModelMitarbeiter mit: deleteItems) {
            sql = "DELETE FROM Mitarbeiter WHERE pindex="+mit.getPIndex()+";";
            dbs.changeDBS(sql);
        }        
        for (ModelMitarbeiter mit : items) {
            if (mit.neu) {
                sql = "INSERT INTO Mitarbeiter(pindex, vorname, nachname, gehaltmonat, gehaltjahr, aindex) "+
                        "Values ("+mit.getPIndex()+", "+mit.getVornameQuote()+
                        ", "+mit.getNachnameQuote()+
                        ", "+mit.getGehaltMonat()+
                        ", "+mit.getGehaltJahr()+
                        ", "+mit.getAIndex()+
                                 ");";
                dbs.changeDBS(sql);
            }
            else {
                if (mit.modify) {
                   sql= "UPDATE Mitarbeiter "+
                        " SET vorname="+mit.getVornameQuote()+
                           ", nachname="+mit.getNachnameQuote()+
                           ", gehaltmonat"+mit.getGehaltMonat()+
                           ", gehaltjahr"+mit.getGehaltJahr()+
                           ", aindex"+mit.getAIndex()+
                        " WHERE pindex="+mit.getPIndex()+";";
                   dbs.changeDBS(sql);
                }
            }
        }
        dbs.shutdownDBS();
        dbs.openDbs();
    } // save2Database

    
    
}
